%% Programme d'identification d'un instrument.
clc
clear all
close all

%%
NbInstru = 4;

%% Rcuperation de la base de donne
cd('./Database')
bdd = fopen('Ident_Drums-test.txt');
BdD = textscan(bdd,'%s','delimiter',':');
fclose(bdd);
cd('./../')

BdD = BdD{1,1};
N = length(BdD); %Taille de la BdD
Sloubi1 = N / 4; %Nombre de lignes par instru
 
%% Rcupration de l'instrument  analyser

inst = fopen('Instrument.txt');
Inst = textscan(inst,'%s','delimiter',':');
fclose(inst);

Inst = Inst{1,1};
M = length(Inst);
Sloubi2 = M / 2;

%% Traitement de la base de donne

j=0;
for i=2 : 2 : N  
   if mod(i,2)==0
        if i == Sloubi1*j+2
           BdD{i,1} = BdD{i,1};
           j = j+1;
        else
           BdD{i,1} = str2num(BdD{i,1});
        end
   end
   
end

%% Traitement de l'instrument

for i=2 : 2 : M 
%    if mod(i,2)==0
    if i == 2
       Inst{i,1} = Inst{i,1};
    else
       Inst{i,1} = str2num(Inst{i,1});
    end     
%    end
end

%% Analyse de l'instrument
 



for j=1 : NbInstru
     occurence(j) = 0;
     for i=2 : 2 : M
         for ii= 4 :4 : N/NbInstru 
            if i ~= 2  && ii+((j-1)*Sloubi2) ~= 24 && 2+ii+((j-1)*Sloubi2) ~= 24
                 if Inst{i,1} <=  BdD{2+ii+((j-1)*Sloubi2),1} && Inst{i,1} >=  BdD{ii+((j-1)*Sloubi2),1}
                     occurence(j) = occurence(j) + 1;
                 end
            end
         end
     end
 end

% for j=1 : M/2-1
%      occurence(j) = 0;
%      for i=2 : 2 : M
%          for ii= 4 :4 : N/4 
%             if i ~= 2 % && 2+ii+((j-1)*Sloubi2) ~= (j-1)*(N/4)+2
%              if Inst{i,1} <=  BdD{2+ii+((j-1)*Sloubi2),1} && Inst{i,1} >=  BdD{ii+((j-1)*Sloubi2),1}
%                  occurence(j) = occurence(j) + 1;
%              end
%             end
%          end
%      end
%  end





% bdd2 = BdD;
% j=1;
% for i=6 : 4 : N  
%     if i == j*Sloubi1
%         i = i+2;
%         j = j+1;
%     end
%    bdd2(i-2,2) = bdd2(i,1);
% end

bdd2 = BdD;
j=1;
for i=4 : 4 : N -2 
    if i == j*Sloubi1+2
        i = i+2;
        j = j+1;
    end
   bdd2(i,2) = bdd2(i+2,1); 
end

% for i = 4 : 4 : Sloubi1-4
%     for j = 1 : 5
%         bdd2(j*i,2) = bdd2(j*i+2,1);
%     end
% end


[A, I] = max(occurence);
a = BdD{(I-1)*Sloubi2+2,1};

sprintf('L''instrument est %s',a) 